bool success;

bool setupSTA() {
  DEBUG("Connecting to AP... ");
  WiFi.softAPdisconnect();
  WiFi.disconnect();
#if defined (IP_STATIC)
  WiFi.config(ip, gateway, subnet, gateway);
#endif
  WiFi.mode(WIFI_STA);
  WiFi.begin(portalCfg.SSID, portalCfg.pass);
  uint32_t tmr = millis();
  bool state = false;
  while (millis() - tmr < 30000) {
    if (WiFi.status() == WL_CONNECTED) {
      DEBUGLN("ok");
      DEBUGLN(WiFi.localIP());
      WiFi.setAutoReconnect(true);
      WiFi.persistent(true);
      return true;
    }
    yield();
  }
  DEBUGLN("fail");
  success = false;
  return false;
//  portalRoutine();
}

//-----------------------------------------------
// Считывает файл wifi.dat
// В случае какой либо неудачи запускает портал с сетью "ESP Config"
void Connect_WiFi_Portal() {
  success=true;
  if (FS_LOAD(portalCfg)) success=false;
  else DEBUGLN(portalCfg.SSID);
  do {
  if (!success)
   {
    DEBUGLN("Start Portal");
    portalStart();
    while (!portalTick());
    if (portalStatus() == SP_SUBMIT) FS_SAVE(portalCfg);
   } 
  } while(!setupSTA()); 
}
